// =====================================================================
/*!
//
//  \file TInputObjectStream.hh
//  \brief This file contains the TInputObjectStream class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TInputObjectStream.hh,v 1.6 2003/12/06 10:56:19 goiwai Exp $
//  $Name: CLDAQ-1-11-00 $
//  $Log: TInputObjectStream.hh,v $
//  Revision 1.6  2003/12/06 10:56:19  goiwai
//  フィルタ関連の修整と Read(),Write()の戻り値の修整です.
//  Read()もWrite()も処理したレコードサイズを返します.
//  フィルタがある場合も同様です.
//  それぞれのストリームのDataSizeの扱いですが,これは扱ったレコードサイズ
//  でなく扱ったファイルやソケットなどのサイズになります.レコードサイズと
//  一致するとは限りません.
//
//  Revision 1.5  2003/11/03 08:35:13  goiwai
//  Doxygen用のタグとコメントをうちこんでいく試みを開始しました.
//
//  Revision 1.4  2003/10/11 02:56:14  goiwai
//  デストラクタを protected から public 属性に変更しました.今さらこんな変
//  更するなんて,へたれだ.
//
//  Revision 1.3  2003/10/06 17:02:42  goiwai
//  *** empty log message ***
//
//  Revision 1.2  2003/07/30 16:19:30  goiwai
//  ファイルにコミットログをつけることにしました.
//
*/
// =====================================================================
#ifndef __TINPUTOBJECTSTREAM_HH
#define __TINPUTOBJECTSTREAM_HH

#include "Tglobals.h"
#include "TObjectStream.hh"

class TStreamableObject;
class TInputObjectFilter;


/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TInputObjectStream
// \brief This is the TInputObjectStream class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TInputObjectStream class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup PersistencyCategory
*/
class TInputObjectStream
  : public TObjectStream
{

  protected:
    TInputObjectFilter* theObjectFilter;

  public:
    TInputObjectStream( Tstream_t streamtype = tUnknownStream );
    TInputObjectStream( TInputObjectFilter* filter, Tstream_t streamtype = tUnknownStream );
    virtual ~TInputObjectStream();

  public:
    TInputObjectFilter* GetObjectFilter() const;
    Tvoid SetObjectFilter( TInputObjectFilter* filter );
    Tbool HasFilter() const;

  public:
    virtual Tint Read( TStreamableObject& object ) = 0;
    friend Tint operator>>( TInputObjectStream& left, TStreamableObject& object );
    friend Tint operator>>( TInputObjectStream& left, const TStreamableObject& object );

};

inline Tint operator>>( TInputObjectStream& left, TStreamableObject& object )
{
  return left.Read( object );
}

inline Tint operator>>( TInputObjectStream& left, const TStreamableObject& object )
{
  return left.Read( *(TStreamableObject*)(&object) );
}

inline TInputObjectFilter* TInputObjectStream::GetObjectFilter() const
{
  return theObjectFilter;
}

inline Tvoid TInputObjectStream::SetObjectFilter( TInputObjectFilter* filter )
{
  theObjectFilter = filter;
  return;
}

inline Tbool TInputObjectStream::HasFilter() const
{
  return ( theObjectFilter != 0 ) ? Ttrue : Tfalse;
}

#endif
